import { FilterDescriptor } from "../models/filterDescriptor";
import { FilterDescriptorBase } from "../models/filterDescriptorBase";
import { FilterGroupDescriptor } from "../models/filterGroupDescriptor";
import { FilterOperator } from "../enums/filterOperator";
export declare class FilterHelper {
    static predicateByFilters<T>(obj: T, filters: FilterDescriptorBase[]): boolean;
    static predicateByFilterGroupDescriptor<T>(obj: T, filterGroupDescriptor: FilterGroupDescriptor<T>): boolean;
    static predicateByFilterDescriptor<T>(obj: T, filterDescriptor: FilterDescriptor<T>): boolean;
    static predicateEqual<T>(obj: T, propertyPath: string, filterValue: any, ignoreCase: any): boolean;
    static predicateNotEqual<T>(obj: T, propertyPath: string, filterValue: any, ignoreCase: any): boolean;
    static predicateLessThan<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static predicateLessThanOrEqual<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static predicateGreaterThanOrEqual<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static predicateGreaterThan<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static predicateStartWith<T>(obj: T, propertyPath: string, filterValue: any, ignoreCase: boolean): boolean;
    static predicateEndWith<T>(obj: T, propertyPath: string, filterValue: any, ignoreCase: boolean): boolean;
    static predicateContains<T>(obj: T, propertyPath: string, filterValue: any, ignoreCase: boolean): boolean;
    static predicateIn<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static predicateNotIn<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static predicateBitwiseAny<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static predicateBitwiseZero<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static predicateBitwiseAll<T>(obj: T, propertyPath: string, filterValue: any): boolean;
    static getFilterValues(operator: FilterOperator, filterValue: any): any[];
    static getRealFilters<T>(filters: FilterDescriptorBase[]): FilterDescriptorBase[];
    static getValue(value: any): any;
}
