import { SortDescriptorBase } from "./sortDescriptorBase";
import { FilterDescriptorBase } from "./filterDescriptorBase";
import { FilterOptions } from "./filterOptions";
import { SortOptions } from "./sortOptions";
import { FilterGroupOptions } from "./filterGroupOptions";
export declare class DynamicQuery<T> {
    type: new () => T;
    filters: FilterDescriptorBase[];
    sorts: SortDescriptorBase[];
    selectedProperties: string[];
    constructor();
    static createQuery<T>(type: new () => T): DynamicQuery<T>;
    addFilters(filters: FilterDescriptorBase[]): DynamicQuery<T>;
    addFilterDescriptor(option: FilterOptions<T>): DynamicQuery<T>;
    addFilterGroupDescriptor(option: FilterGroupOptions<T>): DynamicQuery<T>;
    addSorts(sorts: SortDescriptorBase[]): DynamicQuery<T>;
    addSortDescriptor(sortOption: SortOptions<T>): DynamicQuery<T>;
    selectProperty(property: keyof T): DynamicQuery<T>;
    selectProperties(...properties: (keyof T)[]): DynamicQuery<T>;
    query(datas: T[]): T[];
    toJSON(): string;
    fromJSON(json: string): DynamicQuery<T>;
}
