import { FilterDescriptorBase } from "./filterDescriptorBase";
import { FilterOperator } from "../enums/filterOperator";
import { FilterOptions } from "./filterOptions";
/**
 * Initializes a new instance of the FilterDescriptor class.
 */
export declare class FilterDescriptor<T> extends FilterDescriptorBase {
    operator: FilterOperator;
    propertyPath: string;
    ignoreCase: boolean;
    value: string | number | Date | boolean | Array<string | number | Date | boolean> | null;
    constructor(options?: FilterOptions<T>);
    /**
     * Serialize current FilterDescriptor to json string.
     */
    toJSON(): string;
    /**
     * Deserialize json string to instance of FilterDescriptor.
     * @param json
     */
    fromJSON(json: string): FilterDescriptor<T>;
}
