"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var filterDescriptorBase_1 = require("./filterDescriptorBase");
var filterOperator_1 = require("../enums/filterOperator");
var class_transformer_1 = require("class-transformer");
var ts_commons_1 = require("ts-commons");
/**
 * Initializes a new instance of the FilterDescriptor class.
 */
var FilterDescriptor = /** @class */ (function (_super) {
    __extends(FilterDescriptor, _super);
    function FilterDescriptor(options) {
        var _this = _super.call(this, "FilterDescriptor") || this;
        _this.operator = filterOperator_1.FilterOperator.EQUAL;
        _this.propertyPath = null;
        _this.ignoreCase = false;
        _this.value = null;
        if (options) {
            _this.condition = ts_commons_1.ObjectUtils.isNullOrUndefined(options.condition)
                ? _this.condition
                : options.condition;
            _this.ignoreCase = ts_commons_1.ObjectUtils.isNullOrUndefined(options.ignoreCase)
                ? _this.ignoreCase
                : options.ignoreCase;
            _this.operator = options.operator;
            _this.value = options.value;
            _this.propertyPath = options.propertyPath.toString();
        }
        return _this;
    }
    /**
     * Serialize current FilterDescriptor to json string.
     */
    FilterDescriptor.prototype.toJSON = function () {
        return class_transformer_1.serialize(this);
    };
    /**
     * Deserialize json string to instance of FilterDescriptor.
     * @param json
     */
    FilterDescriptor.prototype.fromJSON = function (json) {
        var obj = class_transformer_1.deserialize(FilterDescriptor, json);
        this.condition = obj.condition;
        this.operator = obj.operator;
        this.value = obj.value;
        this.ignoreCase = obj.ignoreCase;
        this.propertyPath = obj.propertyPath;
        return this;
    };
    return FilterDescriptor;
}(filterDescriptorBase_1.FilterDescriptorBase));
exports.FilterDescriptor = FilterDescriptor;
//# sourceMappingURL=filterDescriptor.js.map