import { FilterDescriptorBase } from "./filterDescriptorBase";
import { FilterOptions } from "./filterOptions";
/**
 * Initializes a new instance of the FilterGroupDescriptor class.
 */
export declare class FilterGroupDescriptor<T> extends FilterDescriptorBase {
    filters: FilterDescriptorBase[];
    constructor();
    /**
     * Add filter array to group.
     * @param filters
     */
    addFilters(filters: FilterDescriptorBase[]): FilterGroupDescriptor<T>;
    /**
     * Add filter item to group
     * @param filterOptions
     */
    addFilter(filterOptions: FilterOptions<T>): FilterGroupDescriptor<T>;
    /**
     * Serialize current FilterGroupDescriptor to json string.
     */
    toJSON(): string;
    /**
     * Deserialize json string to instance of FilterGroupDescriptor.
     * @param json
     */
    fromJSON(json: string): FilterGroupDescriptor<T>;
}
