"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var filterDescriptorBase_1 = require("./filterDescriptorBase");
var class_transformer_1 = require("class-transformer");
var filterDescriptor_1 = require("./filterDescriptor");
var filterHelper_1 = require("../helpers/filterHelper");
/**
 * Initializes a new instance of the FilterGroupDescriptor class.
 */
var FilterGroupDescriptor = /** @class */ (function (_super) {
    __extends(FilterGroupDescriptor, _super);
    function FilterGroupDescriptor() {
        var _this = _super.call(this, "FilterGroupDescriptor") || this;
        _this.filters = [];
        return _this;
    }
    /**
     * Add filter array to group.
     * @param filters
     */
    FilterGroupDescriptor.prototype.addFilters = function (filters) {
        this.filters = this.filters.concat(filters);
        return this;
    };
    /**
     * Add filter item to group
     * @param filterOptions
     */
    FilterGroupDescriptor.prototype.addFilter = function (filterOptions) {
        var filter = new filterDescriptor_1.FilterDescriptor(filterOptions);
        this.filters.push(filter);
        return this;
    };
    /**
     * Serialize current FilterGroupDescriptor to json string.
     */
    FilterGroupDescriptor.prototype.toJSON = function () {
        return class_transformer_1.serialize(this);
    };
    /**
     * Deserialize json string to instance of FilterGroupDescriptor.
     * @param json
     */
    FilterGroupDescriptor.prototype.fromJSON = function (json) {
        var obj = class_transformer_1.deserialize(FilterGroupDescriptor, json);
        this.filters = filterHelper_1.FilterHelper.getRealFilters(obj.filters);
        this.condition = obj.condition;
        return this;
    };
    return FilterGroupDescriptor;
}(filterDescriptorBase_1.FilterDescriptorBase));
exports.FilterGroupDescriptor = FilterGroupDescriptor;
//# sourceMappingURL=filterGroupDescriptor.js.map