import { SortDescriptorBase } from "./sortDescriptorBase";
import { SortDirection } from "../enums/sortDirection";
import { SortOptions } from "./sortOptions";
/**
 * Initializes a new instance of the SortDescriptor class.
 */
export declare class SortDescriptor<T> extends SortDescriptorBase {
    propertyPath: string;
    direction: SortDirection;
    constructor(options?: SortOptions<T>);
    /**
     * Serialize current SortDescriptor to json string.
     */
    toJSON(): string;
    /**
     * Deserialize json string to instance of SortDescriptor.
     * @param json
     */
    fromJSON(json: string): SortDescriptor<T>;
}
