"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var sortDescriptorBase_1 = require("./sortDescriptorBase");
var sortDirection_1 = require("../enums/sortDirection");
var class_transformer_1 = require("class-transformer");
var ts_commons_1 = require("ts-commons");
/**
 * Initializes a new instance of the SortDescriptor class.
 */
var SortDescriptor = /** @class */ (function (_super) {
    __extends(SortDescriptor, _super);
    function SortDescriptor(options) {
        var _this = _super.call(this, "SortDescriptor") || this;
        _this.propertyPath = null;
        _this.direction = sortDirection_1.SortDirection.ASC;
        if (options) {
            _this.direction = ts_commons_1.ObjectUtils.isNullOrUndefined(options.direction)
                ? sortDirection_1.SortDirection.ASC
                : options.direction;
            _this.propertyPath = options.propertyPath.toString();
        }
        return _this;
    }
    /**
     * Serialize current SortDescriptor to json string.
     */
    SortDescriptor.prototype.toJSON = function () {
        return class_transformer_1.serialize(this);
    };
    /**
     * Deserialize json string to instance of SortDescriptor.
     * @param json
     */
    SortDescriptor.prototype.fromJSON = function (json) {
        var obj = class_transformer_1.deserialize(SortDescriptor, json);
        this.direction = obj.direction;
        this.propertyPath = obj.propertyPath;
        return this;
    };
    return SortDescriptor;
}(sortDescriptorBase_1.SortDescriptorBase));
exports.SortDescriptor = SortDescriptor;
//# sourceMappingURL=sortDescriptor.js.map