"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts_commons_1 = require("ts-commons");
var filterHelper_1 = require("../helpers/filterHelper");
var sortHelper_1 = require("../helpers/sortHelper");
var QueryProvider = /** @class */ (function () {
    function QueryProvider() {
    }
    QueryProvider.query = function (datas, query) {
        var _this = this;
        if (ts_commons_1.ArrayUtils.isEmpty(datas)) {
            return [];
        }
        var cloneDatas = datas.slice(0);
        if (ts_commons_1.ObjectUtils.isNullOrUndefined(query)) {
            return cloneDatas;
        }
        if (!ts_commons_1.ArrayUtils.isEmpty(query.filters)) {
            cloneDatas = cloneDatas.filter(function (x) {
                return filterHelper_1.FilterHelper.predicateByFilters(x, query.filters);
            });
        }
        if (!ts_commons_1.ArrayUtils.isEmpty(query.sorts)) {
            cloneDatas = cloneDatas.sort(function (obj1, obj2) {
                return sortHelper_1.SortHelper.predicateBySorts(obj1, obj2, query.sorts);
            });
        }
        if (!ts_commons_1.ArrayUtils.isEmpty(query.selectedProperties)) {
            cloneDatas = cloneDatas.map(function (x) {
                return _this.pick(query.type, x, query.selectedProperties);
            });
        }
        return cloneDatas;
    };
    QueryProvider.pick = function (type, data, selectedProperties) {
        var newObj = ts_commons_1.ObjectUtils.createObject(type);
        for (var key in data) {
            if (selectedProperties.indexOf(key) >= 0) {
                newObj[key] = data[key];
            }
        }
        return newObj;
    };
    return QueryProvider;
}());
exports.QueryProvider = QueryProvider;
//# sourceMappingURL=queryProvider.js.map